package com.muzhi.shennongshi.controller;

import com.muzhi.shennongshi.common.R;
import com.muzhi.shennongshi.service.DingOaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


@Api(description = "钉钉")
@RestController
@RequestMapping("/dingservice")
@CrossOrigin//解决跨域问题
public class DingOaController {

    @Autowired
    private DingOaService dingOaService;

    /**
     * 表单打开时加载（所属主体：改为合同公司）
     */
    @ApiOperation(value = "表单打开时加载（所属主体：改为合同公司）")
    @GetMapping("getSuoshuzhuti")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public Map getSuoshuzhuti(String userid){

        Map suoshuzhuti = dingOaService.getSuoshuzhuti(userid);
        return suoshuzhuti;
    }

    /**
     * 提交审批单后将生效日期等信息写入数据库
     */
    @ApiOperation(value = "提交审批单后将生效日期等信息写入数据库")
    @PostMapping("dateToMySQL")
    public String dateToMySQL(String userid,String htgsid,String sxrq) throws Exception{

        String dateToMySQL = dingOaService.dateToMySQL(userid,htgsid,sxrq);
        return dateToMySQL;
    }

    /**
     * 表单提交审批通过后反写智能人事花名册更新（所属主体：合同公司）
     */
    @ApiOperation(value = "表单提交审批通过后反写智能人事花名册更新（所属主体：合同公司）")
    @PostMapping("updateSuoshuzhuti")
    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public R updateSuoshuzhuti() throws Exception{

        R updateSuoshuzhuti = dingOaService.updateSuoshuzhuti();
        return updateSuoshuzhuti;
    }

    /**
     * 表单打开时加载（人员类型）
     */
    @ApiOperation(value = "表单打开时加载（人员类型）")
    @GetMapping("getRenyuanleixing")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public Map getRenyuanleixing(String userid){

        Map renyuanleixing = dingOaService.getRenyuanleixing(userid);
        return renyuanleixing;
    }

    //表单提交时校验（加班）
    @ApiOperation(value = "表单提交时校验（加班）")
    @GetMapping("getJBJY")
    public Map getJBJY(String ygcj,String sfxjbf,String jbbcfs){

        Map jbjy = dingOaService.getJBJY(ygcj,sfxjbf,jbbcfs);

        return jbjy;
    }

    /**
     * 表单打开时加载（员工假期类型）
     */
    @ApiOperation(value = "表单打开时加载（员工假期类型）")
    @GetMapping("getJiaqileixing")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public String getJiaqileixing(String userid){

        String jiaqileixing = dingOaService.getJiaqileixing(userid);
        return jiaqileixing;
    }

    /**
     * 请假审批表单提交后反校验是否提交单据内容是否符合规则，不符合执行撤销审批实例
     */
    @ApiOperation(value = "表单提交审批通过后反写智能人事花名册更新（所属主体）")
    @PostMapping("revocationProcessInstances")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
//    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public R revocationProcessInstances(String processInstances, String userid){//,String ygjqlx,String userid

        R revocationProcessInstances = dingOaService.revocationProcessInstances(processInstances, userid);//,ygjqlx,userid
        return revocationProcessInstances;
    }

    //表单提交时校验（部门）
//    @ApiOperation(value = "表单提交时校验（部门）")
//    @GetMapping("getBMJY")
//    public Map getBMJY(String bmid){
//
//        Map bmjy = dingOaService.getBMJY(bmid);
//
//        return bmjy;
//    }
}